export { abi } from './abi';
type TokenPair = {
    ctokenSym: string;
    underlySym: string;
    ctokenDecimal: number;
    underlyDecimal: number;
    ctokenIsEther: boolean;
};
export declare const constants: {
    PriceFeed: string;
    Maximillion: string;
    CompoundLens: string;
    GovernorBravo: string;
    Comptroller: string;
    Reservoir: string;
    UnderwriterAdmin: string;
    PriceOracle: string;
    StdComptroller: string;
    WhitepaperInterestRate: string;
};
export declare const getTokenPairs: (networkName: string) => TokenPair[];
export declare const getRateModals: (networkName: string) => any;
export declare const getAddress: (networkName: string, tokenSym: string) => any;
export declare const getName: (networkName: string, tokenAddress: string) => any;
export declare const isCTokenAllowed: (networkName: string, cToken: string) => boolean;
export declare const isUnderlyAllowed: (networkName: string, underlyName: string) => boolean;
export declare const getDecimals: (networkName: string, tokenSym: string) => number;
export declare const getDecimalsOfUnderly: (networkName: string, tokenSym: string) => number;
export declare const isEther: (networkName: string, ctokenSym: string) => boolean;
