"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.netId = void 0;
/**
 * This function acts like a decorator for all methods that interact with the
 *     blockchain. In order to use the correct Compound Protocol addresses, the
 *     Compound.js SDK must know which network its provider points to. This
 *     function holds up a transaction until the main constructor has determined
 *     the network ID.
 *
 * @hidden
 *
 * @param {Compound} _compound The instance of the Compound.js SDK.
 *
 */
async function netId(_compound) {
    if (_compound._networkPromise) {
        await _compound._networkPromise;
    }
}
exports.netId = netId;
//# sourceMappingURL=helpers.js.map