import type { BaseContract, BigNumberish, BytesLike, FunctionFragment, Result, Interface, ContractRunner, ContractMethod, Listener } from "ethers";
import type { TypedContractEvent, TypedDeferredTopicFilter, TypedEventLog, TypedListener, TypedContractMethod } from "../../../common";
export interface ErrorTestInterface extends Interface {
    getFunction(nameOrSignature: "test(uint256,uint256,uint256)" | "test(uint256,uint256)"): FunctionFragment;
    encodeFunctionData(functionFragment: "test(uint256,uint256,uint256)", values: [BigNumberish, BigNumberish, BigNumberish]): string;
    encodeFunctionData(functionFragment: "test(uint256,uint256)", values: [BigNumberish, BigNumberish]): string;
    decodeFunctionResult(functionFragment: "test(uint256,uint256,uint256)", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "test(uint256,uint256)", data: BytesLike): Result;
}
export interface ErrorTest extends BaseContract {
    connect(runner?: ContractRunner | null): ErrorTest;
    waitForDeployment(): Promise<this>;
    interface: ErrorTestInterface;
    queryFilter<TCEvent extends TypedContractEvent>(event: TCEvent, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TypedEventLog<TCEvent>>>;
    queryFilter<TCEvent extends TypedContractEvent>(filter: TypedDeferredTopicFilter<TCEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TypedEventLog<TCEvent>>>;
    on<TCEvent extends TypedContractEvent>(event: TCEvent, listener: TypedListener<TCEvent>): Promise<this>;
    on<TCEvent extends TypedContractEvent>(filter: TypedDeferredTopicFilter<TCEvent>, listener: TypedListener<TCEvent>): Promise<this>;
    once<TCEvent extends TypedContractEvent>(event: TCEvent, listener: TypedListener<TCEvent>): Promise<this>;
    once<TCEvent extends TypedContractEvent>(filter: TypedDeferredTopicFilter<TCEvent>, listener: TypedListener<TCEvent>): Promise<this>;
    listeners<TCEvent extends TypedContractEvent>(event: TCEvent): Promise<Array<TypedListener<TCEvent>>>;
    listeners(eventName?: string): Promise<Array<Listener>>;
    removeAllListeners<TCEvent extends TypedContractEvent>(event?: TCEvent): Promise<this>;
    "test(uint256,uint256,uint256)": TypedContractMethod<[
        err: BigNumberish,
        info: BigNumberish,
        num: BigNumberish
    ], [
        void
    ], "view">;
    "test(uint256,uint256)": TypedContractMethod<[
        err: BigNumberish,
        info: BigNumberish
    ], [
        void
    ], "view">;
    getFunction<T extends ContractMethod = ContractMethod>(key: string | FunctionFragment): T;
    getFunction(nameOrSignature: "test(uint256,uint256,uint256)"): TypedContractMethod<[
        err: BigNumberish,
        info: BigNumberish,
        num: BigNumberish
    ], [
        void
    ], "view">;
    getFunction(nameOrSignature: "test(uint256,uint256)"): TypedContractMethod<[
        err: BigNumberish,
        info: BigNumberish
    ], [
        void
    ], "view">;
    filters: {};
}
