import { ContractFactory, ContractTransactionResponse } from "ethers";
import type { Signer, ContractDeployTransaction, ContractRunner } from "ethers";
import type { NonPayableOverrides } from "../../../common";
import type { TokenErrorReporter, TokenErrorReporterInterface } from "../../../contracts/CToken/TokenErrorReporter";
type TokenErrorReporterConstructorParams = [signer?: Signer] | ConstructorParameters<typeof ContractFactory>;
export declare class TokenErrorReporter__factory extends ContractFactory {
    constructor(...args: TokenErrorReporterConstructorParams);
    getDeployTransaction(overrides?: NonPayableOverrides & {
        from?: string;
    }): Promise<ContractDeployTransaction>;
    deploy(overrides?: NonPayableOverrides & {
        from?: string;
    }): Promise<TokenErrorReporter & {
        deploymentTransaction(): ContractTransactionResponse;
    }>;
    connect(runner: ContractRunner | null): TokenErrorReporter__factory;
    static readonly bytecode = "0x60808060405234601757603a9081601d823930815050f35b600080fdfe600080fdfea2646970667358221220edadee7ffe2eb5c25d5caedceb5d91ee8b087a7493e1daa8541201c460d2e24b64736f6c63430008130033";
    static readonly abi: readonly [{
        readonly inputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "errorCode";
            readonly type: "uint256";
        }, {
            readonly internalType: "uint256";
            readonly name: "infoCode";
            readonly type: "uint256";
        }, {
            readonly internalType: "uint256";
            readonly name: "detailCode";
            readonly type: "uint256";
        }];
        readonly name: "TokenError";
        readonly type: "error";
    }, {
        readonly anonymous: false;
        readonly inputs: readonly [{
            readonly indexed: false;
            readonly internalType: "uint256";
            readonly name: "error";
            readonly type: "uint256";
        }, {
            readonly indexed: false;
            readonly internalType: "uint256";
            readonly name: "info";
            readonly type: "uint256";
        }, {
            readonly indexed: false;
            readonly internalType: "uint256";
            readonly name: "detail";
            readonly type: "uint256";
        }];
        readonly name: "Failure";
        readonly type: "event";
    }];
    static createInterface(): TokenErrorReporterInterface;
    static connect(address: string, runner?: ContractRunner | null): TokenErrorReporter;
}
export {};
