import { type ContractRunner } from "ethers";
import type { ICompLogic, ICompLogicInterface } from "../../../contracts/Interface/ICompLogic";
export declare class ICompLogic__factory {
    static readonly abi: readonly [{
        readonly inputs: readonly [{
            readonly internalType: "address";
            readonly name: "cToken";
            readonly type: "address";
        }, {
            readonly internalType: "address";
            readonly name: "borrower";
            readonly type: "address";
        }, {
            readonly components: readonly [{
                readonly internalType: "uint256";
                readonly name: "mantissa";
                readonly type: "uint256";
            }];
            readonly internalType: "struct Exp";
            readonly name: "marketBorrowIndex";
            readonly type: "tuple";
        }];
        readonly name: "distributeBorrowerComp";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "address";
            readonly name: "cToken";
            readonly type: "address";
        }, {
            readonly internalType: "address";
            readonly name: "supplier";
            readonly type: "address";
        }];
        readonly name: "distributeSupplierComp";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [];
        readonly name: "getRedemptionRate";
        readonly outputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "";
            readonly type: "uint256";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "address";
            readonly name: "cToken";
            readonly type: "address";
        }, {
            readonly internalType: "uint32";
            readonly name: "blockNumber";
            readonly type: "uint32";
        }];
        readonly name: "initializeMarket";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "address";
            readonly name: "cToken";
            readonly type: "address";
        }, {
            readonly internalType: "uint256";
            readonly name: "supplySpeed";
            readonly type: "uint256";
        }, {
            readonly internalType: "uint256";
            readonly name: "borrowSpeed";
            readonly type: "uint256";
        }];
        readonly name: "setCompSpeed";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "redeemAmount";
            readonly type: "uint256";
        }, {
            readonly internalType: "uint256";
            readonly name: "_totalSupply";
            readonly type: "uint256";
        }];
        readonly name: "updateBaseRateFromRedemption";
        readonly outputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "";
            readonly type: "uint256";
        }];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "address";
            readonly name: "cToken";
            readonly type: "address";
        }, {
            readonly components: readonly [{
                readonly internalType: "uint256";
                readonly name: "mantissa";
                readonly type: "uint256";
            }];
            readonly internalType: "struct Exp";
            readonly name: "marketBorrowIndex";
            readonly type: "tuple";
        }];
        readonly name: "updateCompBorrowIndex";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "address";
            readonly name: "cToken";
            readonly type: "address";
        }];
        readonly name: "updateCompSupplyIndex";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }];
    static createInterface(): ICompLogicInterface;
    static connect(address: string, runner?: ContractRunner | null): ICompLogic;
}
